#LIST FGDB/GPKG
#DESCRIBE FGDB/GPKG, 
#SHOW GFGDB/GPKG LAYER DATAFRAME
#PLOT FGDB/GPKG LAYER

#Libraries and packages
library (rgdal)
library(sf)

#List FGDB/GPKG layers
path <- "D:/FILES/DATASCIENCE/2021-07-ma_ihdp/data/active/ihdp/" #Change path to your local path
fgdb_file <- "ssd_ihdp_c19_s0_pp_v01/gis/arcgis/ssd_ihdp_c19_s0_pp.gdb"
gpkg_file <- "ssd_ihdp_c19_s0_pp_v01/gis/qgis/ssd_ihdp_c19_s0_pp.gpkg"

fgdb <- paste0(path,fgdb_file)
gpkg <- paste0(path,gpkg_file)

print("FGDB layers")
ogrListLayers(fgdb)
print("GPKG layers")
ogrListLayers(gpkg)

#Describe a FGDB/GPKG layer
lyr_name = "ssd_admn_ad0_py_s0_c19ihdp_pp"
lyr_fgdb <- readOGR(dsn=fgdb, layer=lyr_name)
lyr_gpkg <- readOGR(dsn=gpkg, layer=lyr_name)

print("FGDB")
print(class(lyr_fgdb))
ogrInfo(dsn=fgdb, layer=lyr_name)
print("GPKG")
print(class(lyr_gpkg))
ogrInfo(dsn=gpkg, layer=lyr_name)

#Display a FGDB/GPKG layer data frame
print("FGDB")
lyr_fgdb.df <- as(lyr_fgdb, "data.frame")
print(lyr_fgdb.df)

print("GPKG")
lyr_gpkg.df <- as(lyr_gpkg, "data.frame")
print(lyr_gpkg.df)

#Display a FGDB/GPKG layer
plot(lyr_fgdb, main="FGDB")
plot(lyr_gpkg, main="GPKG")