#LIST FGDB/GPKG
#DESCRIBE FGDB/GPKG, 
#SHOW GFGDB/GPKG LAYER DATAFRAME
#PLOT FGDB/GPKG LAYER

#Libraries and packages
from osgeo import ogr

#List FGDB/GPKG layers
path = "D:/FILES/DATASCIENCE/2021-07-ma_ihdp/data/active/ihdp/" #Change path to your local path
fgdb_file = "ssd_ihdp_c19_s0_pp_v01/gis/arcgis/ssd_ihdp_c19_s0_pp.gdb"
gpkg_file = "ssd_ihdp_c19_s0_pp_v01/gis/qgis/ssd_ihdp_c19_s0_pp.gpkg"

fgdb = path + fgdb_file
gpkg = path + gpkg_file

print("FGDB layers")
conn_fgdb = ogr.Open(fgdb)
featsClassList = []
for featsClass_idx in range(conn_fgdb.GetLayerCount()):
    featsClass = conn_fgdb.GetLayerByIndex(featsClass_idx)
    featsClassList.append(featsClass.GetName())
featsClassList.sort()
for featsClass in featsClassList:
    print(featsClass)

print("GPKG layers")
conn_gpkg = ogr.Open(gpkg)
featsClassList = []
for featsClass_idx in range(conn_gpkg.GetLayerCount()):
    featsClass = conn_gpkg.GetLayerByIndex(featsClass_idx)
    featsClassList.append(featsClass.GetName())
featsClassList.sort()
for featsClass in featsClassList:
    print(featsClass)

#Describe a FGDB/GPKG layer
lyr_name = "ssd_admn_ad0_py_s0_c19ihdp_pp"
lyr_fgdb = conn_fgdb.GetLayer(lyr_name)
lyr_gpkg = conn_gpkg.GetLayer(lyr_name)

print("FGDB")
print(str(lyr_fgdb.GetFeatureCount()) + " Features")
layerDefinition = lyr_fgdb.GetLayerDefn()
for i in range(layerDefinition.GetFieldCount()):
    print("Field %d: %s" % ( i+1, layerDefinition.GetFieldDefn(i).GetName() ))
print("GPKG")
print(str(lyr_gpkg.GetFeatureCount()) + " Features")
layerDefinition = lyr_gpkg.GetLayerDefn()
for i in range(layerDefinition.GetFieldCount()):
    print("Field %d: %s" % ( i+1, layerDefinition.GetFieldDefn(i).GetName() ))

#Display a FGDB/GPKG layer data frame
print("FGDB")
layerDefinition = lyr_fgdb.GetLayerDefn()
field_list = []
for i in range(layerDefinition.GetFieldCount()):
    field_name = layerDefinition.GetFieldDefn(i).GetName()
    field_list.append(field_name)

for x in field_list:
    print('FIELD {}'.format(x))
    for feature in lyr_fgdb:
        feat = feature.GetField(x)
        print(feat)
    lyr_fgdb.ResetReading()  # reset the read position to the start

print("GPKG")
layerDefinition = lyr_gpkg.GetLayerDefn()
field_list = []
for i in range(layerDefinition.GetFieldCount()):
    field_name = layerDefinition.GetFieldDefn(i).GetName()
    field_list.append(field_name)

for x in field_list:
    print('FIELD {}'.format(x))
    for feature in lyr_gpkg:
        feat = feature.GetField(x)
        print(feat)
    lyr_gpkg.ResetReading()  # reset the read position to the start

#Display a FGDB/GPKG layer
